Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/Server.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/Server.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/Server.cs	(revision 2223)
@@ -27,23 +27,23 @@
 using System.Net;
 using System.ServiceModel;
-using HeuristicLab.CEDMA.DB.Interfaces;
-using HeuristicLab.CEDMA.DB;
 using System.ServiceModel.Description;
 using HeuristicLab.Grid;
 using HeuristicLab.Grid.HiveBridge;
 using HeuristicLab.Core;
+using HeuristicLab.Modeling.Database;
+using HeuristicLab.Modeling.Database.SQLServerCompact;
 
 namespace HeuristicLab.CEDMA.Server {
   public class Server : IViewable {
-    private static readonly string rdfFile = AppDomain.CurrentDomain.BaseDirectory + "rdf_store.db3";
-    private static readonly string rdfConnectionString = "sqlite:rdf:Data Source=\"" + rdfFile + "\"";
+    private static readonly string sqlServerCompactFile = AppDomain.CurrentDomain.BaseDirectory + "HeuristicLab.Modeling.database.sdf";
+    private static readonly string sqlServerCompactConnectionString = @"Data Source=" + sqlServerCompactFile;
 
-    private ServiceHost host;
-    private Store store;
-
+    private DatabaseService database;
     private IDispatcher dispatcher;
     public IDispatcher Dispatcher { get { return dispatcher; } }
     private IExecuter executer;
     public IExecuter Executer { get { return executer; } }
+    private Problem problem;
+    public Problem Problem { get { return problem; } }
 
     private string gridServiceUrl;
@@ -53,46 +53,16 @@
     }
 
-    private string cedmaServiceUrl;
-    public string CedmaServiceUrl {
-      get { return cedmaServiceUrl; }
-      set { cedmaServiceUrl = value; }
-    }
-
     public Server() {
-      IPAddress[] addresses = Dns.GetHostAddresses(Dns.GetHostName());
-      // windows XP returns the external ip on index 0 while windows vista returns the external ip as one of the last entries
-      // also if IPv6 protocol is installed we want to find an entry that is IPv4
-      int index = 0;
-      if (System.Environment.OSVersion.Version.Major >= 6) {
-        for (index = addresses.Length - 1; index >= 0; index--)
-          if (addresses[index].AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
-            break;
+      database = new DatabaseService(sqlServerCompactConnectionString);
+      problem = new Problem();
+      try {
+        problem.Dataset = database.GetDataset();
       }
-      cedmaServiceUrl = "net.tcp://" + addresses[index] + ":8002/CEDMA";
-      store = new Store(rdfConnectionString);
-    }
-
-    public void Start() {
-      host = new ServiceHost(store, new Uri(cedmaServiceUrl));
-      ServiceThrottlingBehavior throttlingBehavior = new ServiceThrottlingBehavior();
-      throttlingBehavior.MaxConcurrentSessions = 20;
-      host.Description.Behaviors.Add(throttlingBehavior);
-      try {
-        NetTcpBinding binding = new NetTcpBinding();
-        binding.SendTimeout = new TimeSpan(10, 0, 0);
-        binding.MaxReceivedMessageSize = int.MaxValue;
-        binding.ReaderQuotas.MaxStringContentLength = int.MaxValue;
-        binding.ReaderQuotas.MaxArrayLength = int.MaxValue;
-        host.AddServiceEndpoint(typeof(IStore), binding, cedmaServiceUrl);
-        host.Open();
-      }
-      catch (CommunicationException ex) {
-        MessageBox.Show("An exception occurred: " + ex.Message);
-        host.Abort();
+      catch (InvalidOperationException ex) {
       }
     }
 
     internal void Connect(string serverUrl) {
-      dispatcher = new SimpleDispatcher(store);
+      dispatcher = new SimpleDispatcher(database, problem);
       IGridServer gridServer = null;
       if (serverUrl.Contains("ExecutionEngine")) {
@@ -102,5 +72,5 @@
         gridServer = new GridServerProxy(serverUrl);
       }
-      executer = new GridExecuter(dispatcher, store, gridServer);
+      executer = new GridExecuter(dispatcher, gridServer, database);
       executer.Start();
     }
@@ -110,5 +80,4 @@
       return new ServerView(this);
     }
-
     #endregion
   }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs	(revision 2223)
@@ -27,14 +27,13 @@
 
 namespace HeuristicLab.CEDMA.Server {
-  [ClassInfo(Name = "CEDMA Server", Description = "Server to execute CEDMA agents.", AutoRestart=true)]
+  [ClassInfo(Name = "CEDMA", Description = "Cooperative Evolutionary Data Mining.", AutoRestart=true)]
   class ServerApplication : ApplicationBase {
     public override void Run() {
       Server server = new Server();
-      server.Start();
       Form mainForm = new Form();
       UserControl serverControl = (UserControl)server.CreateView();
       serverControl.Dock = DockStyle.Fill;
       mainForm.Controls.Add(serverControl);
-      mainForm.Name = "CEDMA Server";
+      mainForm.Name = "CEDMA";
       Application.Run(mainForm);
     }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.cs	(revision 2223)
@@ -32,6 +32,4 @@
 using HeuristicLab.PluginInfrastructure;
 using System.Net;
-using HeuristicLab.CEDMA.DB;
-using HeuristicLab.CEDMA.DB.Interfaces;
 using System.Data.Common;
 using System.Threading;
@@ -47,5 +45,4 @@
       this.server = server;
       InitializeComponent();
-      addressTextBox.Text = server.CedmaServiceUrl;
     }
 
@@ -58,4 +55,7 @@
       dispatcherControl.Dock = DockStyle.Fill;
       dispatcherTabPage.Controls.Add(dispatcherControl);
+      UserControl problemControl = (UserControl)server.Problem.CreateView();
+      problemControl.Dock = DockStyle.Fill;
+      problemPage.Controls.Add(problemControl);
       connectButton.Enabled = false;      
     }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.designer.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/ServerView.designer.cs	(revision 2223)
@@ -45,6 +45,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.addressTextBox = new System.Windows.Forms.TextBox();
-      this.externalAddressLabel = new System.Windows.Forms.Label();
       this.gridAddressLabel = new System.Windows.Forms.Label();
       this.address = new System.Windows.Forms.TextBox();
@@ -53,23 +51,7 @@
       this.executerTabPage = new System.Windows.Forms.TabPage();
       this.dispatcherTabPage = new System.Windows.Forms.TabPage();
+      this.problemPage = new System.Windows.Forms.TabPage();
       this.tabControl.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // addressTextBox
-      // 
-      this.addressTextBox.Location = new System.Drawing.Point(106, 6);
-      this.addressTextBox.Name = "addressTextBox";
-      this.addressTextBox.ReadOnly = true;
-      this.addressTextBox.Size = new System.Drawing.Size(229, 20);
-      this.addressTextBox.TabIndex = 0;
-      // 
-      // externalAddressLabel
-      // 
-      this.externalAddressLabel.AutoSize = true;
-      this.externalAddressLabel.Location = new System.Drawing.Point(12, 9);
-      this.externalAddressLabel.Name = "externalAddressLabel";
-      this.externalAddressLabel.Size = new System.Drawing.Size(48, 13);
-      this.externalAddressLabel.TabIndex = 3;
-      this.externalAddressLabel.Text = "&Address:";
       // 
       // gridAddressLabel
@@ -106,4 +88,5 @@
       this.tabControl.Controls.Add(this.executerTabPage);
       this.tabControl.Controls.Add(this.dispatcherTabPage);
+      this.tabControl.Controls.Add(this.problemPage);
       this.tabControl.Location = new System.Drawing.Point(3, 58);
       this.tabControl.Name = "tabControl";
@@ -132,5 +115,15 @@
       this.dispatcherTabPage.UseVisualStyleBackColor = true;
       // 
-      // ServerForm
+      // problemPage
+      // 
+      this.problemPage.Location = new System.Drawing.Point(4, 22);
+      this.problemPage.Name = "problemPage";
+      this.problemPage.Padding = new System.Windows.Forms.Padding(3);
+      this.problemPage.Size = new System.Drawing.Size(565, 517);
+      this.problemPage.TabIndex = 2;
+      this.problemPage.Text = "Problem";
+      this.problemPage.UseVisualStyleBackColor = true;
+      // 
+      // ServerView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -140,7 +133,5 @@
       this.Controls.Add(this.gridAddressLabel);
       this.Controls.Add(this.address);
-      this.Controls.Add(this.externalAddressLabel);
-      this.Controls.Add(this.addressTextBox);
-      this.Name = "ServerForm";
+      this.Name = "ServerView";
       this.Size = new System.Drawing.Size(579, 604);
       this.tabControl.ResumeLayout(false);
@@ -152,6 +143,4 @@
     #endregion
 
-    private System.Windows.Forms.TextBox addressTextBox;
-    private System.Windows.Forms.Label externalAddressLabel;
     private System.Windows.Forms.Label gridAddressLabel;
     private System.Windows.Forms.TextBox address;
@@ -160,4 +149,5 @@
     private System.Windows.Forms.TabPage executerTabPage;
     private System.Windows.Forms.TabPage dispatcherTabPage;
+    private System.Windows.Forms.TabPage problemPage;
   }
 }
Index: /trunk/sources/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs
===================================================================
--- /trunk/sources/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs	(revision 2223)
@@ -27,6 +27,4 @@
 using System.Net;
 using System.ServiceModel;
-using HeuristicLab.CEDMA.DB.Interfaces;
-using HeuristicLab.CEDMA.DB;
 using System.ServiceModel.Description;
 using System.Linq;
@@ -35,4 +33,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Modeling;
+using HeuristicLab.Modeling.Database;
 
 namespace HeuristicLab.CEDMA.Server {
@@ -44,11 +43,9 @@
     }
 
-    private Random random;
-    private IStore store;
+    private Random random;    
     private Dictionary<int, List<AlgorithmConfiguration>> finishedAndDispatchedRuns;
 
-    public SimpleDispatcher(IStore store)
-      : base(store) {
-      this.store = store;
+    public SimpleDispatcher(IModelingDatabase database, Problem problem)
+      : base(database, problem) {      
       random = new Random();
       finishedAndDispatchedRuns = new Dictionary<int, List<AlgorithmConfiguration>>();
@@ -56,8 +53,8 @@
     }
 
-    public override IAlgorithm SelectAndConfigureAlgorithm(int targetVariable, int[] inputVariables, Problem problem) {
+    public override HeuristicLab.Modeling.IAlgorithm SelectAndConfigureAlgorithm(int targetVariable, int[] inputVariables, Problem problem) {
       DiscoveryService ds = new DiscoveryService();
-      IAlgorithm[] algos = ds.GetInstances<IAlgorithm>();
-      IAlgorithm selectedAlgorithm = null;
+      HeuristicLab.Modeling.IAlgorithm[] algos = ds.GetInstances<HeuristicLab.Modeling.IAlgorithm>();
+      HeuristicLab.Modeling.IAlgorithm selectedAlgorithm = null;
       switch (problem.LearningTask) {
         case LearningTask.Regression: {
@@ -86,5 +83,5 @@
     }
 
-    private IAlgorithm ChooseDeterministic(int targetVariable, int[] inputVariables, IEnumerable<IAlgorithm> algos) {
+    private HeuristicLab.Modeling.IAlgorithm ChooseDeterministic(int targetVariable, int[] inputVariables, IEnumerable<HeuristicLab.Modeling.IAlgorithm> algos) {
       var deterministicAlgos = algos
         .Where(a => (a as IStochasticAlgorithm) == null)
@@ -95,5 +92,5 @@
     }
 
-    private IAlgorithm ChooseStochastic(IEnumerable<IAlgorithm> regressionAlgos) {
+    private HeuristicLab.Modeling.IAlgorithm ChooseStochastic(IEnumerable<HeuristicLab.Modeling.IAlgorithm> regressionAlgos) {
       var stochasticAlgos = regressionAlgos.Where(a => (a as IStochasticAlgorithm) != null);
       if (stochasticAlgos.Count() == 0) return null;
@@ -102,53 +99,53 @@
 
     private void PopulateFinishedRuns() {
-      Dictionary<Entity, Entity> processedModels = new Dictionary<Entity, Entity>();
-      var datasetBindings = store
-        .Query(
-        "?Dataset <" + Ontology.InstanceOf + "> <" + Ontology.TypeDataSet + "> .", 0, 1)
-        .Select(x => (Entity)x.Get("Dataset"));
-
-      if (datasetBindings.Count() > 0) {
-        var datasetEntity = datasetBindings.ElementAt(0);
-
-        DataSet ds = new DataSet(store, datasetEntity);
-        var result = store
-          .Query(
-          "?Model <" + Ontology.TargetVariable + "> ?TargetVariable ." + Environment.NewLine +
-          "?Model <" + Ontology.Name + "> ?AlgoName .",
-          0, 1000)
-          .Select(x => new Resource[] { (Literal)x.Get("TargetVariable"), (Literal)x.Get("AlgoName"), (Entity)x.Get("Model") });
-
-        foreach (Resource[] row in result) {
-          Entity model = ((Entity)row[2]);
-          if (!processedModels.ContainsKey(model)) {
-            processedModels.Add(model, model);
-
-            string targetVariable = (string)((Literal)row[0]).Value;
-            string algoName = (string)((Literal)row[1]).Value;
-            int targetVariableIndex = ds.Problem.Dataset.GetVariableIndex(targetVariable);
-
-            var inputVariableLiterals = store
-              .Query(
-                "<" + model.Uri + "> <" + Ontology.HasInputVariable + "> ?InputVariable ." + Environment.NewLine +
-                "?InputVariable <" + Ontology.Name + "> ?Name .",
-                0, 1000)
-              .Select(x => (Literal)x.Get("Name"))
-              .Select(l => (string)l.Value)
-              .Distinct();
-
-            List<int> inputVariables = new List<int>();
-            foreach (string variableName in inputVariableLiterals) {
-              int variableIndex = ds.Problem.Dataset.GetVariableIndex(variableName);
-              inputVariables.Add(variableIndex);
-            }
-            if (!AlgorithmFinishedOrDispatched(targetVariableIndex, inputVariables.ToArray(), algoName)) {
-              AddDispatchedRun(targetVariableIndex, inputVariables.ToArray(), algoName);
-            }
-          }
-        }
-      }
-    }
-
-    private void SetProblemParameters(IAlgorithm algo, Problem problem, int targetVariable, int[] inputVariables) {
+      //Dictionary<Entity, Entity> processedModels = new Dictionary<Entity, Entity>();
+      //var datasetBindings = store
+      //  .Query(
+      //  "?Dataset <" + Ontology.InstanceOf + "> <" + Ontology.TypeDataSet + "> .", 0, 1)
+      //  .Select(x => (Entity)x.Get("Dataset"));
+
+      //if (datasetBindings.Count() > 0) {
+      //  var datasetEntity = datasetBindings.ElementAt(0);
+
+      //  DataSet ds = new DataSet(store, datasetEntity);
+      //  var result = store
+      //    .Query(
+      //    "?Model <" + Ontology.TargetVariable + "> ?TargetVariable ." + Environment.NewLine +
+      //    "?Model <" + Ontology.Name + "> ?AlgoName .",
+      //    0, 1000)
+      //    .Select(x => new Resource[] { (Literal)x.Get("TargetVariable"), (Literal)x.Get("AlgoName"), (Entity)x.Get("Model") });
+
+      //  foreach (Resource[] row in result) {
+      //    Entity model = ((Entity)row[2]);
+      //    if (!processedModels.ContainsKey(model)) {
+      //      processedModels.Add(model, model);
+
+      //      string targetVariable = (string)((Literal)row[0]).Value;
+      //      string algoName = (string)((Literal)row[1]).Value;
+      //      int targetVariableIndex = ds.Problem.Dataset.GetVariableIndex(targetVariable);
+
+      //      var inputVariableLiterals = store
+      //        .Query(
+      //          "<" + model.Uri + "> <" + Ontology.HasInputVariable + "> ?InputVariable ." + Environment.NewLine +
+      //          "?InputVariable <" + Ontology.Name + "> ?Name .",
+      //          0, 1000)
+      //        .Select(x => (Literal)x.Get("Name"))
+      //        .Select(l => (string)l.Value)
+      //        .Distinct();
+
+      //      List<int> inputVariables = new List<int>();
+      //      foreach (string variableName in inputVariableLiterals) {
+      //        int variableIndex = ds.Problem.Dataset.GetVariableIndex(variableName);
+      //        inputVariables.Add(variableIndex);
+      //      }
+      //      if (!AlgorithmFinishedOrDispatched(targetVariableIndex, inputVariables.ToArray(), algoName)) {
+      //        AddDispatchedRun(targetVariableIndex, inputVariables.ToArray(), algoName);
+      //      }
+      //    }
+      //  }
+      //}
+    }
+
+    private void SetProblemParameters(HeuristicLab.Modeling.IAlgorithm algo, Problem problem, int targetVariable, int[] inputVariables) {
       algo.Dataset = problem.Dataset;
       algo.TargetVariable = targetVariable;
Index: /trunk/sources/HeuristicLab.DataAnalysis/3.2/Dataset.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAnalysis/3.2/Dataset.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.DataAnalysis/3.2/Dataset.cs	(revision 2223)
@@ -111,4 +111,7 @@
 
     private string[] variableNames;
+    public IEnumerable<string> VariableNames {
+      get { return variableNames; }
+    }
 
     public Dataset() {
@@ -123,4 +126,6 @@
       fireChangeEvents = true;
     }
+
+    
 
     public string GetVariableName(int variableIndex) {
Index: /trunk/sources/HeuristicLab.DataAnalysis/3.2/DatasetView.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataAnalysis/3.2/DatasetView.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.DataAnalysis/3.2/DatasetView.cs	(revision 2223)
@@ -37,15 +37,4 @@
       : base() {
       InitializeComponent();
-      DiscoveryService discovery = new DiscoveryService();
-      IDatasetManipulator[] manipuators = discovery.GetInstances<IDatasetManipulator>();
-      contextMenuStrip.Items.Add(new ToolStripSeparator());
-      foreach(IDatasetManipulator manipulator in manipuators) {
-        contextMenuStrip.Items.Add(new ToolStripButton(manipulator.Action,null , delegate(object source, EventArgs args) 
-          { 
-            manipulator.Execute(Dataset);
-            Refresh();
-          }));
-      }
-      
       // format all cells with the round-trip formatter to make sure that values that are exported and imported to
       // another C# app (HL2) have the same numeric value
@@ -60,4 +49,13 @@
       : this() {
       this.Dataset = dataset;
+      DiscoveryService discovery = new DiscoveryService();
+      IDatasetManipulator[] manipuators = discovery.GetInstances<IDatasetManipulator>();
+      contextMenuStrip.Items.Add(new ToolStripSeparator());
+      foreach (IDatasetManipulator manipulator in manipuators) {
+        contextMenuStrip.Items.Add(new ToolStripButton(manipulator.Action, null, delegate(object source, EventArgs args) {
+          manipulator.Execute(Dataset);
+          Refresh();
+        }));
+      }      
     }
 
Index: /trunk/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.GP.Boolean/3.3/FunctionLibraryInjector.cs	(revision 2223)
@@ -28,5 +28,5 @@
 using HeuristicLab.DataAnalysis;
 using HeuristicLab.GP.Interfaces;
-using HeuristicLab.GP.SantaFe;
+using HeuristicLab.GP;
 
 namespace HeuristicLab.GP.Boolean {
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/AlgorithmBase.cs	(revision 2223)
@@ -70,9 +70,13 @@
     }
 
+    private IModel model;
     public virtual IModel Model {
       get {
         if (!engine.Terminated) throw new InvalidOperationException("The algorithm is still running. Wait until the algorithm is terminated to retrieve the result.");
-        IScope bestModelScope = engine.GlobalScope.GetVariableValue<IScope>("BestValidationSolution", false);
-        return CreateGPModel(bestModelScope);
+        if (model == null) {
+          IScope bestModelScope = engine.GlobalScope.GetVariableValue<IScope>("BestValidationSolution", false);
+          model = CreateGPModel(bestModelScope);
+        }
+        return model;
       }
     }
@@ -434,4 +438,5 @@
         double impact = ((DoubleData)row[1]).Data;
         model.SetVariableEvaluationImpact(variableName, impact);
+        model.AddInputVariables(variableName);
       }
       foreach (ItemList row in qualityImpacts) {
@@ -439,4 +444,5 @@
         double impact = ((DoubleData)row[1]).Data;
         model.SetVariableQualityImpact(variableName, impact);
+        model.AddInputVariables(variableName);
       }
       Engine.GlobalScope.RemoveSubScope(bestModelScope);
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/FunctionLibraryInjector.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/FunctionLibraryInjector.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/FunctionLibraryInjector.cs	(revision 2223)
@@ -24,5 +24,5 @@
 using HeuristicLab.Data;
 using HeuristicLab.GP.Interfaces;
-using HeuristicLab.GP.SantaFe;
+using HeuristicLab.GP;
 
 namespace HeuristicLab.GP.StructureIdentification {
Index: /trunk/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionLibraryInjectorBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionLibraryInjectorBase.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.GP/3.3/BaseClasses/FunctionLibraryInjectorBase.cs	(revision 2223)
@@ -28,5 +28,5 @@
 using HeuristicLab.GP.Interfaces;
 
-namespace HeuristicLab.GP.SantaFe {
+namespace HeuristicLab.GP {
   public abstract class FunctionLibraryInjectorBase : OperatorBase {
     private const string FUNCTIONLIBRARY = "FunctionLibrary";
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/LinearRegression.cs	(revision 2223)
@@ -293,4 +293,5 @@
         double impact = ((DoubleData)row[1]).Data;
         model.SetVariableEvaluationImpact(variableName, impact);
+        model.AddInputVariables(variableName);
       }
       foreach (ItemList row in qualityImpacts) {
@@ -298,4 +299,5 @@
         double impact = ((DoubleData)row[1]).Data;
         model.SetVariableQualityImpact(variableName, impact);
+        model.AddInputVariables(variableName);
       }
 
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Algorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Algorithm.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/Algorithm.cs	(revision 2223)
@@ -0,0 +1,45 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "Algorithm")]
+  public class Algorithm : IAlgorithm  {
+    public Algorithm() {
+    }
+
+    public Algorithm(string name)
+      : this() {
+      this.name = name;
+    }
+
+    public Algorithm(string name, string description)
+      : this(name) {
+      this.description = description;
+    }
+
+    private int id;
+    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
+    public int Id {
+      get { return this.id; }
+      private set { this.id = value; }
+    }
+
+    private string name;
+    [Column(Storage = "name", CanBeNull = false)]
+    public string Name {
+      get { return this.name; }
+      set { this.name = value; }
+    }
+
+    private string description;
+    [Column(Storage = "description", CanBeNull = true)]
+    public string Description {
+      get { return this.description; }
+      set { this.description = value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariable.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariable.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariable.cs	(revision 2223)
@@ -0,0 +1,67 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name = "InputVariable")]
+  public class InputVariable : IInputVariable {
+    public InputVariable() {
+      this.model = default(EntityRef<Model>);
+      this.variable = default(EntityRef<Variable>);
+    }
+
+    public InputVariable(Model model, Variable variable)
+      : base() {
+      this.modelId = model.Id;
+      this.variableId = variable.Id;
+    }
+
+    private int variableId;
+    [Column(Storage = "variableId", IsPrimaryKey = true)]
+    public int VariableId {
+      get { return this.variableId; }
+      private set {
+        if (variableId != value) {
+          if (variable.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          variableId = value;          
+        }
+      }
+    }
+
+    private EntityRef<Variable> variable;
+    [Association(Storage = "variable", ThisKey = "VariableId", OtherKey = "Id", IsForeignKey = true)]
+    public Variable Variable {
+      get { return variable.Entity; }
+    }
+
+    IVariable IInputVariable.Variable {
+      get { return this.Variable; }
+    }
+
+    private int modelId;
+    [Column(Storage = "modelId", IsPrimaryKey = true)]
+    public int ModelId {
+      get { return this.modelId; }
+      private set {
+        if (modelId != value) {
+          if (model.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          modelId = value;
+        }
+      }
+    }
+
+    private EntityRef<Model> model;
+    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
+    public Model Model {
+      get { return model.Entity; }
+    }
+
+    IModel IInputVariable.Model {
+      get { return this.Model;}
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariableResult.cs
===================================================================
--- /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariableResult.cs	(revision 2223)
+++ /trunk/sources/HeuristicLab.Modeling.Database.SQLServerCompact/3.2/DataObjects/InputVariableResult.cs	(revision 2223)
@@ -0,0 +1,100 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Data.Linq;
+using System.Data.Linq.Mapping;
+using System.Text;
+
+namespace HeuristicLab.Modeling.Database.SQLServerCompact {
+  [Table(Name="InputVariableResult")]
+  public class InputVariableResult : IInputVariableResult {
+    public InputVariableResult() {
+      this.model = default(EntityRef<Model>);
+      this.variable = default(EntityRef<Variable>);
+      this.result = default(EntityRef<Result>);
+    }
+
+    public InputVariableResult(InputVariable inputVariable, Result result, double value)
+      : this() {
+      this.variableId = inputVariable.VariableId;
+      this.modelId = inputVariable.ModelId;
+      this.resultId = result.Id;
+      this.value = value;
+    }
+
+    private int variableId;
+    [Column(Storage = "variableId", IsPrimaryKey = true)]
+    public int VariableId {
+      get { return this.variableId; }
+      private set {
+        if (variableId != value) {
+          if (variable.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          variableId = value;
+        }
+      }
+    }
+
+    private EntityRef<Variable> variable;
+    [Association(Storage = "variable", ThisKey = "VariableId", OtherKey = "Id", IsForeignKey = true)]
+    public Variable Variable {
+      get { return variable.Entity; }
+    }
+
+    IVariable IInputVariableResult.Variable {
+      get { return this.Variable; }
+    }
+
+    private int modelId;
+    [Column(Storage = "modelId", IsPrimaryKey = true)]
+    public int ModelId {
+      get { return this.modelId; }
+      private set {
+        if (modelId != value) {
+          if (model.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          modelId = value;
+        }
+      }
+    }
+
+    private EntityRef<Model> model;
+    [Association(Storage = "model", ThisKey = "ModelId", OtherKey = "Id", IsForeignKey = true)]
+    public Model Model {
+      get { return model.Entity; }
+    }
+
+    IModel IInputVariableResult.Model {
+      get { return this.Model; }
+    }
+
+    private int resultId;
+    [Column(Storage = "resultId", IsPrimaryKey = true)]
+    public int ResultId {
+      get { return this.resultId; }
+      private set {
+        if (resultId != value) {
+          if (result.HasLoadedOrAssignedValue)
+            throw new ForeignKeyReferenceAlreadyHasValueException();
+          resultId = value;
+        }
+      }
+    }
+
+    private EntityRef<Result> result;
+    [Association(Storage = "result", ThisKey = "ResultId", OtherKey = "Id", IsForeignKey = true)]
+    public Result Result {
+      get { return result.Entity; }
+    }
+
+    IResult IInputVariableResult.Result {
+      get { return this.Result; }
+    }
+
+    private double value;
+    [Column(Storage = "value", CanBeNull = false)]
+    public double Value {
+      get { return this.value; }
+      set { this.value = value; }
+    }
+  }
+}
